# encoding: utf-8
# **********************************************************************
#
# Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.6.3
#
# <auto-generated>
#
# Generated from file `FileServer.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

require 'Ice'
require 'IcePatch2/FileInfo.rb'

module IcePatch2

    if not defined?(::IcePatch2::T_ByteSeqSeq)
        T_ByteSeqSeq = ::Ice::__defineSequence('::IcePatch2::ByteSeqSeq', ::Ice::T_ByteSeq)
    end

    if not defined?(::IcePatch2::PartitionOutOfRangeException)
        class PartitionOutOfRangeException < Ice::UserException
            def initialize
            end

            def to_s
                'IcePatch2::PartitionOutOfRangeException'
            end
        end

        T_PartitionOutOfRangeException = ::Ice::__defineException('::IcePatch2::PartitionOutOfRangeException', PartitionOutOfRangeException, false, nil, [])
        PartitionOutOfRangeException::ICE_TYPE = T_PartitionOutOfRangeException
    end

    if not defined?(::IcePatch2::FileAccessException)
        class FileAccessException < Ice::UserException
            def initialize(reason='')
                @reason = reason
            end

            def to_s
                'IcePatch2::FileAccessException'
            end

            attr_accessor :reason
        end

        T_FileAccessException = ::Ice::__defineException('::IcePatch2::FileAccessException', FileAccessException, false, nil, [["reason", ::Ice::T_string, false, 0]])
        FileAccessException::ICE_TYPE = T_FileAccessException
    end

    if not defined?(::IcePatch2::FileSizeRangeException)
        class FileSizeRangeException < ::IcePatch2::FileAccessException
            def initialize(reason='')
                super(reason)
            end

            def to_s
                'IcePatch2::FileSizeRangeException'
            end
        end

        T_FileSizeRangeException = ::Ice::__defineException('::IcePatch2::FileSizeRangeException', FileSizeRangeException, false, ::IcePatch2::T_FileAccessException, [])
        FileSizeRangeException::ICE_TYPE = T_FileSizeRangeException
    end

    if not defined?(::IcePatch2::FileServer_mixin)
        module FileServer_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IcePatch2::FileServer']
            end

            def ice_id(current=nil)
                '::IcePatch2::FileServer'
            end

            #
            # Operation signatures.
            #
            # def getFileInfoSeq(partition, current=nil)
            # def getLargeFileInfoSeq(partition, current=nil)
            # def getChecksumSeq(current=nil)
            # def getChecksum(current=nil)
            # def getFileCompressed(path, pos, num, current=nil)
            # def getLargeFileCompressed(path, pos, num, current=nil)

            def inspect
                ::Ice::__stringify(self, T_FileServer)
            end
        end
        class FileServer
            include FileServer_mixin
            
            def FileServer.ice_staticId()
                '::IcePatch2::FileServer'
            end
        end
        module FileServerPrx_mixin

            def getFileInfoSeq(partition, _ctx=nil)
                FileServer_mixin::OP_getFileInfoSeq.invoke(self, [partition], _ctx)
            end

            def getLargeFileInfoSeq(partition, _ctx=nil)
                FileServer_mixin::OP_getLargeFileInfoSeq.invoke(self, [partition], _ctx)
            end

            def getChecksumSeq(_ctx=nil)
                FileServer_mixin::OP_getChecksumSeq.invoke(self, [], _ctx)
            end

            def getChecksum(_ctx=nil)
                FileServer_mixin::OP_getChecksum.invoke(self, [], _ctx)
            end

            def getFileCompressed(path, pos, num, _ctx=nil)
                FileServer_mixin::OP_getFileCompressed.invoke(self, [path, pos, num], _ctx)
            end

            def getLargeFileCompressed(path, pos, num, _ctx=nil)
                FileServer_mixin::OP_getLargeFileCompressed.invoke(self, [path, pos, num], _ctx)
            end
        end
        class FileServerPrx < ::Ice::ObjectPrx
            include FileServerPrx_mixin

            def FileServerPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IcePatch2::FileServer', facetOrCtx, _ctx)
            end

            def FileServerPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def FileServerPrx.ice_staticId()
                '::IcePatch2::FileServer'
            end
        end

        if not defined?(::IcePatch2::T_FileServer)
            T_FileServer = ::Ice::__declareClass('::IcePatch2::FileServer')
            T_FileServerPrx = ::Ice::__declareProxy('::IcePatch2::FileServer')
        end

        T_FileServer.defineClass(FileServer, -1, true, false, nil, [], [])
        FileServer_mixin::ICE_TYPE = T_FileServer

        T_FileServerPrx.defineProxy(FileServerPrx, T_FileServer)
        FileServerPrx::ICE_TYPE = T_FileServerPrx

        FileServer_mixin::OP_getFileInfoSeq = ::Ice::__defineOperation('getFileInfoSeq', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [[::Ice::T_int, false, 0]], [], [::IcePatch2::T_FileInfoSeq, false, 0], [::IcePatch2::T_PartitionOutOfRangeException, ::IcePatch2::T_FileSizeRangeException])
        FileServer_mixin::OP_getFileInfoSeq.deprecate("getFileInfoSeq() is deprecated, use getLargeFileInfoSeq() instead.")
        FileServer_mixin::OP_getLargeFileInfoSeq = ::Ice::__defineOperation('getLargeFileInfoSeq', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [[::Ice::T_int, false, 0]], [], [::IcePatch2::T_LargeFileInfoSeq, false, 0], [::IcePatch2::T_PartitionOutOfRangeException])
        FileServer_mixin::OP_getChecksumSeq = ::Ice::__defineOperation('getChecksumSeq', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::IcePatch2::T_ByteSeqSeq, false, 0], [])
        FileServer_mixin::OP_getChecksum = ::Ice::__defineOperation('getChecksum', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::Ice::T_ByteSeq, false, 0], [])
        FileServer_mixin::OP_getFileCompressed = ::Ice::__defineOperation('getFileCompressed', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, true, nil, [[::Ice::T_string, false, 0], [::Ice::T_int, false, 0], [::Ice::T_int, false, 0]], [], [::Ice::T_ByteSeq, false, 0], [::IcePatch2::T_FileAccessException, ::IcePatch2::T_FileSizeRangeException])
        FileServer_mixin::OP_getFileCompressed.deprecate("getFileCompressed() is deprecated, use getLargeFileCompressed() instead.")
        FileServer_mixin::OP_getLargeFileCompressed = ::Ice::__defineOperation('getLargeFileCompressed', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, true, nil, [[::Ice::T_string, false, 0], [::Ice::T_long, false, 0], [::Ice::T_int, false, 0]], [], [::Ice::T_ByteSeq, false, 0], [::IcePatch2::T_FileAccessException])
    end
end
