# encoding: utf-8
# **********************************************************************
#
# Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.6.3
#
# <auto-generated>
#
# Generated from file `IceStorm.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

require 'Ice'
require 'Ice/Identity.rb'
require 'Ice/SliceChecksumDict.rb'
require 'IceStorm/Metrics.rb'

module IceStorm

    if not defined?(::IceStorm::T_Topic)
        T_Topic = ::Ice::__declareClass('::IceStorm::Topic')
        T_TopicPrx = ::Ice::__declareProxy('::IceStorm::Topic')
    end

    if not defined?(::IceStorm::LinkInfo)
        class LinkInfo
            def initialize(theTopic=nil, name='', cost=0)
                @theTopic = theTopic
                @name = name
                @cost = cost
            end

            def hash
                _h = 0
                _h = 5 * _h + @theTopic.hash
                _h = 5 * _h + @name.hash
                _h = 5 * _h + @cost.hash
                _h % 0x7fffffff
            end

            def ==(other)
                return false if
                    @theTopic != other.theTopic or
                    @name != other.name or
                    @cost != other.cost
                true
            end

            def eql?(other)
                return other.class == self.class && other == self
            end

            def inspect
                ::Ice::__stringify(self, T_LinkInfo)
            end

            attr_accessor :theTopic, :name, :cost
        end

        T_LinkInfo = ::Ice::__defineStruct('::IceStorm::LinkInfo', LinkInfo, [
            ["theTopic", ::IceStorm::T_TopicPrx],
            ["name", ::Ice::T_string],
            ["cost", ::Ice::T_int]
        ])
    end

    if not defined?(::IceStorm::T_LinkInfoSeq)
        T_LinkInfoSeq = ::Ice::__defineSequence('::IceStorm::LinkInfoSeq', ::IceStorm::T_LinkInfo)
    end

    if not defined?(::IceStorm::T_QoS)
        T_QoS = ::Ice::__defineDictionary('::IceStorm::QoS', ::Ice::T_string, ::Ice::T_string)
    end

    if not defined?(::IceStorm::LinkExists)
        class LinkExists < Ice::UserException
            def initialize(name='')
                @name = name
            end

            def to_s
                'IceStorm::LinkExists'
            end

            attr_accessor :name
        end

        T_LinkExists = ::Ice::__defineException('::IceStorm::LinkExists', LinkExists, false, nil, [["name", ::Ice::T_string, false, 0]])
        LinkExists::ICE_TYPE = T_LinkExists
    end

    if not defined?(::IceStorm::NoSuchLink)
        class NoSuchLink < Ice::UserException
            def initialize(name='')
                @name = name
            end

            def to_s
                'IceStorm::NoSuchLink'
            end

            attr_accessor :name
        end

        T_NoSuchLink = ::Ice::__defineException('::IceStorm::NoSuchLink', NoSuchLink, false, nil, [["name", ::Ice::T_string, false, 0]])
        NoSuchLink::ICE_TYPE = T_NoSuchLink
    end

    if not defined?(::IceStorm::AlreadySubscribed)
        class AlreadySubscribed < Ice::UserException
            def initialize
            end

            def to_s
                'IceStorm::AlreadySubscribed'
            end
        end

        T_AlreadySubscribed = ::Ice::__defineException('::IceStorm::AlreadySubscribed', AlreadySubscribed, false, nil, [])
        AlreadySubscribed::ICE_TYPE = T_AlreadySubscribed
    end

    if not defined?(::IceStorm::InvalidSubscriber)
        class InvalidSubscriber < Ice::UserException
            def initialize(reason='')
                @reason = reason
            end

            def to_s
                'IceStorm::InvalidSubscriber'
            end

            attr_accessor :reason
        end

        T_InvalidSubscriber = ::Ice::__defineException('::IceStorm::InvalidSubscriber', InvalidSubscriber, false, nil, [["reason", ::Ice::T_string, false, 0]])
        InvalidSubscriber::ICE_TYPE = T_InvalidSubscriber
    end

    if not defined?(::IceStorm::BadQoS)
        class BadQoS < Ice::UserException
            def initialize(reason='')
                @reason = reason
            end

            def to_s
                'IceStorm::BadQoS'
            end

            attr_accessor :reason
        end

        T_BadQoS = ::Ice::__defineException('::IceStorm::BadQoS', BadQoS, false, nil, [["reason", ::Ice::T_string, false, 0]])
        BadQoS::ICE_TYPE = T_BadQoS
    end

    if not defined?(::IceStorm::Topic_mixin)
        module Topic_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IceStorm::Topic']
            end

            def ice_id(current=nil)
                '::IceStorm::Topic'
            end

            #
            # Operation signatures.
            #
            # def getName(current=nil)
            # def getPublisher(current=nil)
            # def getNonReplicatedPublisher(current=nil)
            # def subscribeAndGetPublisher(theQoS, subscriber, current=nil)
            # def unsubscribe(subscriber, current=nil)
            # def link(linkTo, cost, current=nil)
            # def unlink(linkTo, current=nil)
            # def getLinkInfoSeq(current=nil)
            # def getSubscribers(current=nil)
            # def destroy(current=nil)

            def inspect
                ::Ice::__stringify(self, T_Topic)
            end
        end
        class Topic
            include Topic_mixin
            
            def Topic.ice_staticId()
                '::IceStorm::Topic'
            end
        end
        module TopicPrx_mixin

            def getName(_ctx=nil)
                Topic_mixin::OP_getName.invoke(self, [], _ctx)
            end

            def getPublisher(_ctx=nil)
                Topic_mixin::OP_getPublisher.invoke(self, [], _ctx)
            end

            def getNonReplicatedPublisher(_ctx=nil)
                Topic_mixin::OP_getNonReplicatedPublisher.invoke(self, [], _ctx)
            end

            def subscribeAndGetPublisher(theQoS, subscriber, _ctx=nil)
                Topic_mixin::OP_subscribeAndGetPublisher.invoke(self, [theQoS, subscriber], _ctx)
            end

            def unsubscribe(subscriber, _ctx=nil)
                Topic_mixin::OP_unsubscribe.invoke(self, [subscriber], _ctx)
            end

            def link(linkTo, cost, _ctx=nil)
                Topic_mixin::OP_link.invoke(self, [linkTo, cost], _ctx)
            end

            def unlink(linkTo, _ctx=nil)
                Topic_mixin::OP_unlink.invoke(self, [linkTo], _ctx)
            end

            def getLinkInfoSeq(_ctx=nil)
                Topic_mixin::OP_getLinkInfoSeq.invoke(self, [], _ctx)
            end

            def getSubscribers(_ctx=nil)
                Topic_mixin::OP_getSubscribers.invoke(self, [], _ctx)
            end

            def destroy(_ctx=nil)
                Topic_mixin::OP_destroy.invoke(self, [], _ctx)
            end
        end
        class TopicPrx < ::Ice::ObjectPrx
            include TopicPrx_mixin

            def TopicPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IceStorm::Topic', facetOrCtx, _ctx)
            end

            def TopicPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def TopicPrx.ice_staticId()
                '::IceStorm::Topic'
            end
        end

        if not defined?(::IceStorm::T_Topic)
            T_Topic = ::Ice::__declareClass('::IceStorm::Topic')
            T_TopicPrx = ::Ice::__declareProxy('::IceStorm::Topic')
        end

        T_Topic.defineClass(Topic, -1, true, false, nil, [], [])
        Topic_mixin::ICE_TYPE = T_Topic

        T_TopicPrx.defineProxy(TopicPrx, T_Topic)
        TopicPrx::ICE_TYPE = T_TopicPrx

        Topic_mixin::OP_getName = ::Ice::__defineOperation('getName', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::Ice::T_string, false, 0], [])
        Topic_mixin::OP_getPublisher = ::Ice::__defineOperation('getPublisher', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::Ice::T_ObjectPrx, false, 0], [])
        Topic_mixin::OP_getNonReplicatedPublisher = ::Ice::__defineOperation('getNonReplicatedPublisher', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::Ice::T_ObjectPrx, false, 0], [])
        Topic_mixin::OP_subscribeAndGetPublisher = ::Ice::__defineOperation('subscribeAndGetPublisher', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::IceStorm::T_QoS, false, 0], [::Ice::T_ObjectPrx, false, 0]], [], [::Ice::T_ObjectPrx, false, 0], [::IceStorm::T_AlreadySubscribed, ::IceStorm::T_InvalidSubscriber, ::IceStorm::T_BadQoS])
        Topic_mixin::OP_unsubscribe = ::Ice::__defineOperation('unsubscribe', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Idempotent, false, nil, [[::Ice::T_ObjectPrx, false, 0]], [], nil, [])
        Topic_mixin::OP_link = ::Ice::__defineOperation('link', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::IceStorm::T_TopicPrx, false, 0], [::Ice::T_int, false, 0]], [], nil, [::IceStorm::T_LinkExists])
        Topic_mixin::OP_unlink = ::Ice::__defineOperation('unlink', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::IceStorm::T_TopicPrx, false, 0]], [], nil, [::IceStorm::T_NoSuchLink])
        Topic_mixin::OP_getLinkInfoSeq = ::Ice::__defineOperation('getLinkInfoSeq', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::IceStorm::T_LinkInfoSeq, false, 0], [])
        Topic_mixin::OP_getSubscribers = ::Ice::__defineOperation('getSubscribers', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [], [], [::Ice::T_IdentitySeq, false, 0], [])
        Topic_mixin::OP_destroy = ::Ice::__defineOperation('destroy', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [], [], nil, [])
    end

    if not defined?(::IceStorm::T_TopicDict)
        T_TopicDict = ::Ice::__defineDictionary('::IceStorm::TopicDict', ::Ice::T_string, ::IceStorm::T_TopicPrx)
    end

    if not defined?(::IceStorm::TopicExists)
        class TopicExists < Ice::UserException
            def initialize(name='')
                @name = name
            end

            def to_s
                'IceStorm::TopicExists'
            end

            attr_accessor :name
        end

        T_TopicExists = ::Ice::__defineException('::IceStorm::TopicExists', TopicExists, false, nil, [["name", ::Ice::T_string, false, 0]])
        TopicExists::ICE_TYPE = T_TopicExists
    end

    if not defined?(::IceStorm::NoSuchTopic)
        class NoSuchTopic < Ice::UserException
            def initialize(name='')
                @name = name
            end

            def to_s
                'IceStorm::NoSuchTopic'
            end

            attr_accessor :name
        end

        T_NoSuchTopic = ::Ice::__defineException('::IceStorm::NoSuchTopic', NoSuchTopic, false, nil, [["name", ::Ice::T_string, false, 0]])
        NoSuchTopic::ICE_TYPE = T_NoSuchTopic
    end

    if not defined?(::IceStorm::TopicManager_mixin)
        module TopicManager_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IceStorm::TopicManager']
            end

            def ice_id(current=nil)
                '::IceStorm::TopicManager'
            end

            #
            # Operation signatures.
            #
            # def create(name, current=nil)
            # def retrieve(name, current=nil)
            # def retrieveAll(current=nil)
            # def getSliceChecksums(current=nil)

            def inspect
                ::Ice::__stringify(self, T_TopicManager)
            end
        end
        class TopicManager
            include TopicManager_mixin
            
            def TopicManager.ice_staticId()
                '::IceStorm::TopicManager'
            end
        end
        module TopicManagerPrx_mixin

            def create(name, _ctx=nil)
                TopicManager_mixin::OP_create.invoke(self, [name], _ctx)
            end

            def retrieve(name, _ctx=nil)
                TopicManager_mixin::OP_retrieve.invoke(self, [name], _ctx)
            end

            def retrieveAll(_ctx=nil)
                TopicManager_mixin::OP_retrieveAll.invoke(self, [], _ctx)
            end

            def getSliceChecksums(_ctx=nil)
                TopicManager_mixin::OP_getSliceChecksums.invoke(self, [], _ctx)
            end
        end
        class TopicManagerPrx < ::Ice::ObjectPrx
            include TopicManagerPrx_mixin

            def TopicManagerPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IceStorm::TopicManager', facetOrCtx, _ctx)
            end

            def TopicManagerPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def TopicManagerPrx.ice_staticId()
                '::IceStorm::TopicManager'
            end
        end

        if not defined?(::IceStorm::T_TopicManager)
            T_TopicManager = ::Ice::__declareClass('::IceStorm::TopicManager')
            T_TopicManagerPrx = ::Ice::__declareProxy('::IceStorm::TopicManager')
        end

        T_TopicManager.defineClass(TopicManager, -1, true, false, nil, [], [])
        TopicManager_mixin::ICE_TYPE = T_TopicManager

        T_TopicManagerPrx.defineProxy(TopicManagerPrx, T_TopicManager)
        TopicManagerPrx::ICE_TYPE = T_TopicManagerPrx

        TopicManager_mixin::OP_create = ::Ice::__defineOperation('create', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [[::Ice::T_string, false, 0]], [], [::IceStorm::T_TopicPrx, false, 0], [::IceStorm::T_TopicExists])
        TopicManager_mixin::OP_retrieve = ::Ice::__defineOperation('retrieve', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [[::Ice::T_string, false, 0]], [], [::IceStorm::T_TopicPrx, false, 0], [::IceStorm::T_NoSuchTopic])
        TopicManager_mixin::OP_retrieveAll = ::Ice::__defineOperation('retrieveAll', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::IceStorm::T_TopicDict, false, 0], [])
        TopicManager_mixin::OP_getSliceChecksums = ::Ice::__defineOperation('getSliceChecksums', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, nil, [], [], [::Ice::T_SliceChecksumDict, false, 0], [])
    end

    if not defined?(::IceStorm::Finder_mixin)
        module Finder_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IceStorm::Finder']
            end

            def ice_id(current=nil)
                '::IceStorm::Finder'
            end

            #
            # Operation signatures.
            #
            # def getTopicManager(current=nil)

            def inspect
                ::Ice::__stringify(self, T_Finder)
            end
        end
        class Finder
            include Finder_mixin
            
            def Finder.ice_staticId()
                '::IceStorm::Finder'
            end
        end
        module FinderPrx_mixin

            def getTopicManager(_ctx=nil)
                Finder_mixin::OP_getTopicManager.invoke(self, [], _ctx)
            end
        end
        class FinderPrx < ::Ice::ObjectPrx
            include FinderPrx_mixin

            def FinderPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IceStorm::Finder', facetOrCtx, _ctx)
            end

            def FinderPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def FinderPrx.ice_staticId()
                '::IceStorm::Finder'
            end
        end

        if not defined?(::IceStorm::T_Finder)
            T_Finder = ::Ice::__declareClass('::IceStorm::Finder')
            T_FinderPrx = ::Ice::__declareProxy('::IceStorm::Finder')
        end

        T_Finder.defineClass(Finder, -1, true, false, nil, [], [])
        Finder_mixin::ICE_TYPE = T_Finder

        T_FinderPrx.defineProxy(FinderPrx, T_Finder)
        FinderPrx::ICE_TYPE = T_FinderPrx

        Finder_mixin::OP_getTopicManager = ::Ice::__defineOperation('getTopicManager', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, nil, [], [], [::IceStorm::T_TopicManagerPrx, false, 0], [])
    end
end
